import java.util.*;

public class Semaphore {

    private int sv;
    private Queue<Thread> w = new ArrayDeque<Thread>();

    public Semaphore(int sv) {
	this.sv = sv;
    }

    public synchronized void P() throws InterruptedException {
	Thread ct = Thread.currentThread();
	nap(250);
	while (sv==0 || (!w.isEmpty() && !ct.equals(w.peek()))) {
	    if (!w.contains(ct))
		w.add(ct);
	    System.out.println(Thread.currentThread().getName()+" going to wait");
	    wait();
	}
	w.poll();
	sv--;
    }

    private int count = 0;

    public synchronized void V() {
	if (count==0)
	    nap(500);
	count++;
	sv++;
	notifyAll();
    }

    public static void nap(int ms) {
	try {
	    Thread.sleep(ms);
	}
	catch (InterruptedException e) {
	}
    }

    public static void main(String[] args) {
	final Semaphore s = new Semaphore(1);
	try { s.P(); } catch (InterruptedException e) {}

	(new Thread("T1") {
		public void run() {
		    try {
			System.out.println(getName()+" going for P");
			s.P();
			System.out.println(getName()+" done P");
			nap(1000);
			s.V();
			System.out.println(getName()+" done V");
		    }
		    catch (InterruptedException e) {}
		}
	    }).start();
	(new Thread("T2") {
		public void run() {
		    try {
			System.out.println(getName()+" going for P");
			s.P();
			System.out.println(getName()+" done P");
			nap(1000);
			s.V();
			System.out.println(getName()+" done V");
		    }
		    catch (InterruptedException e) {}
		}
	    }).start();
	(new Thread("T3") {
		public void run() {
		    try {
			System.out.println(getName()+" going for P");
			s.P();
			System.out.println(getName()+" done P");
			nap(1000);
			s.V();
			System.out.println(getName()+" done V");
		    }
		    catch (InterruptedException e) {}
		}
	    }).start();
	(new Thread("T4") {
		public void run() {
		    try {
			System.out.println(getName()+" going for P");
			s.P();
			System.out.println(getName()+" done P");
			nap(1000);
			s.V();
			System.out.println(getName()+" done V");
		    }
		    catch (InterruptedException e) {}
		}
	    }).start();
	(new Thread("T5") {
		public void run() {
		    try {
			nap(1510);
			System.out.println(getName()+" going for P");
			s.P();
			System.out.println(getName()+" done P");
			s.V();
			System.out.println(getName()+" done V");
		    }
		    catch (InterruptedException e) {}
		}
	    }).start();

	nap(1500);
	System.out.println("Main going for V");
	s.V();
	System.out.println("Main done V");
    }
 
}
